// Generated by the protocol buffer compiler.  DO NOT EDIT!
// source: commonmodule/commonmodule.proto

package openfmb.commonmodule;

/**
 * <pre>
 * MISSING DOCUMENTATION!!!
 * </pre>
 *
 * Protobuf type {@code commonmodule.TmVoltPoint}
 */
public final class TmVoltPoint extends
    com.google.protobuf.GeneratedMessageV3 implements
    // @@protoc_insertion_point(message_implements:commonmodule.TmVoltPoint)
    TmVoltPointOrBuilder {
private static final long serialVersionUID = 0L;
  // Use TmVoltPoint.newBuilder() to construct.
  private TmVoltPoint(com.google.protobuf.GeneratedMessageV3.Builder<?> builder) {
    super(builder);
  }
  private TmVoltPoint() {
  }

  @java.lang.Override
  @SuppressWarnings({"unused"})
  protected java.lang.Object newInstance(
      UnusedPrivateParameter unused) {
    return new TmVoltPoint();
  }

  public static final com.google.protobuf.Descriptors.Descriptor
      getDescriptor() {
    return openfmb.commonmodule.Commonmodule.internal_static_commonmodule_TmVoltPoint_descriptor;
  }

  @java.lang.Override
  protected com.google.protobuf.GeneratedMessageV3.FieldAccessorTable
      internalGetFieldAccessorTable() {
    return openfmb.commonmodule.Commonmodule.internal_static_commonmodule_TmVoltPoint_fieldAccessorTable
        .ensureFieldAccessorsInitialized(
            openfmb.commonmodule.TmVoltPoint.class, openfmb.commonmodule.TmVoltPoint.Builder.class);
  }

  public static final int TMVAL_FIELD_NUMBER = 1;
  private openfmb.commonmodule.ClearingTime tmVal_;
  /**
   * <pre>
   * MISSING DOCUMENTATION!!!
   * </pre>
   *
   * <code>.commonmodule.ClearingTime tmVal = 1 [(.uml.option_required_field) = true, (.uml.option_multiplicity_min) = 1];</code>
   * @return Whether the tmVal field is set.
   */
  @java.lang.Override
  public boolean hasTmVal() {
    return tmVal_ != null;
  }
  /**
   * <pre>
   * MISSING DOCUMENTATION!!!
   * </pre>
   *
   * <code>.commonmodule.ClearingTime tmVal = 1 [(.uml.option_required_field) = true, (.uml.option_multiplicity_min) = 1];</code>
   * @return The tmVal.
   */
  @java.lang.Override
  public openfmb.commonmodule.ClearingTime getTmVal() {
    return tmVal_ == null ? openfmb.commonmodule.ClearingTime.getDefaultInstance() : tmVal_;
  }
  /**
   * <pre>
   * MISSING DOCUMENTATION!!!
   * </pre>
   *
   * <code>.commonmodule.ClearingTime tmVal = 1 [(.uml.option_required_field) = true, (.uml.option_multiplicity_min) = 1];</code>
   */
  @java.lang.Override
  public openfmb.commonmodule.ClearingTimeOrBuilder getTmValOrBuilder() {
    return tmVal_ == null ? openfmb.commonmodule.ClearingTime.getDefaultInstance() : tmVal_;
  }

  public static final int VOLTVAL_FIELD_NUMBER = 2;
  private float voltVal_ = 0F;
  /**
   * <pre>
   * This is an absolute value field.
   * </pre>
   *
   * <code>float voltVal = 2 [(.uml.option_required_field) = true, (.uml.option_multiplicity_min) = 1];</code>
   * @return The voltVal.
   */
  @java.lang.Override
  public float getVoltVal() {
    return voltVal_;
  }

  private byte memoizedIsInitialized = -1;
  @java.lang.Override
  public final boolean isInitialized() {
    byte isInitialized = memoizedIsInitialized;
    if (isInitialized == 1) return true;
    if (isInitialized == 0) return false;

    memoizedIsInitialized = 1;
    return true;
  }

  @java.lang.Override
  public void writeTo(com.google.protobuf.CodedOutputStream output)
                      throws java.io.IOException {
    if (tmVal_ != null) {
      output.writeMessage(1, getTmVal());
    }
    if (java.lang.Float.floatToRawIntBits(voltVal_) != 0) {
      output.writeFloat(2, voltVal_);
    }
    getUnknownFields().writeTo(output);
  }

  @java.lang.Override
  public int getSerializedSize() {
    int size = memoizedSize;
    if (size != -1) return size;

    size = 0;
    if (tmVal_ != null) {
      size += com.google.protobuf.CodedOutputStream
        .computeMessageSize(1, getTmVal());
    }
    if (java.lang.Float.floatToRawIntBits(voltVal_) != 0) {
      size += com.google.protobuf.CodedOutputStream
        .computeFloatSize(2, voltVal_);
    }
    size += getUnknownFields().getSerializedSize();
    memoizedSize = size;
    return size;
  }

  @java.lang.Override
  public boolean equals(final java.lang.Object obj) {
    if (obj == this) {
     return true;
    }
    if (!(obj instanceof openfmb.commonmodule.TmVoltPoint)) {
      return super.equals(obj);
    }
    openfmb.commonmodule.TmVoltPoint other = (openfmb.commonmodule.TmVoltPoint) obj;

    if (hasTmVal() != other.hasTmVal()) return false;
    if (hasTmVal()) {
      if (!getTmVal()
          .equals(other.getTmVal())) return false;
    }
    if (java.lang.Float.floatToIntBits(getVoltVal())
        != java.lang.Float.floatToIntBits(
            other.getVoltVal())) return false;
    if (!getUnknownFields().equals(other.getUnknownFields())) return false;
    return true;
  }

  @java.lang.Override
  public int hashCode() {
    if (memoizedHashCode != 0) {
      return memoizedHashCode;
    }
    int hash = 41;
    hash = (19 * hash) + getDescriptor().hashCode();
    if (hasTmVal()) {
      hash = (37 * hash) + TMVAL_FIELD_NUMBER;
      hash = (53 * hash) + getTmVal().hashCode();
    }
    hash = (37 * hash) + VOLTVAL_FIELD_NUMBER;
    hash = (53 * hash) + java.lang.Float.floatToIntBits(
        getVoltVal());
    hash = (29 * hash) + getUnknownFields().hashCode();
    memoizedHashCode = hash;
    return hash;
  }

  public static openfmb.commonmodule.TmVoltPoint parseFrom(
      java.nio.ByteBuffer data)
      throws com.google.protobuf.InvalidProtocolBufferException {
    return PARSER.parseFrom(data);
  }
  public static openfmb.commonmodule.TmVoltPoint parseFrom(
      java.nio.ByteBuffer data,
      com.google.protobuf.ExtensionRegistryLite extensionRegistry)
      throws com.google.protobuf.InvalidProtocolBufferException {
    return PARSER.parseFrom(data, extensionRegistry);
  }
  public static openfmb.commonmodule.TmVoltPoint parseFrom(
      com.google.protobuf.ByteString data)
      throws com.google.protobuf.InvalidProtocolBufferException {
    return PARSER.parseFrom(data);
  }
  public static openfmb.commonmodule.TmVoltPoint parseFrom(
      com.google.protobuf.ByteString data,
      com.google.protobuf.ExtensionRegistryLite extensionRegistry)
      throws com.google.protobuf.InvalidProtocolBufferException {
    return PARSER.parseFrom(data, extensionRegistry);
  }
  public static openfmb.commonmodule.TmVoltPoint parseFrom(byte[] data)
      throws com.google.protobuf.InvalidProtocolBufferException {
    return PARSER.parseFrom(data);
  }
  public static openfmb.commonmodule.TmVoltPoint parseFrom(
      byte[] data,
      com.google.protobuf.ExtensionRegistryLite extensionRegistry)
      throws com.google.protobuf.InvalidProtocolBufferException {
    return PARSER.parseFrom(data, extensionRegistry);
  }
  public static openfmb.commonmodule.TmVoltPoint parseFrom(java.io.InputStream input)
      throws java.io.IOException {
    return com.google.protobuf.GeneratedMessageV3
        .parseWithIOException(PARSER, input);
  }
  public static openfmb.commonmodule.TmVoltPoint parseFrom(
      java.io.InputStream input,
      com.google.protobuf.ExtensionRegistryLite extensionRegistry)
      throws java.io.IOException {
    return com.google.protobuf.GeneratedMessageV3
        .parseWithIOException(PARSER, input, extensionRegistry);
  }
  public static openfmb.commonmodule.TmVoltPoint parseDelimitedFrom(java.io.InputStream input)
      throws java.io.IOException {
    return com.google.protobuf.GeneratedMessageV3
        .parseDelimitedWithIOException(PARSER, input);
  }
  public static openfmb.commonmodule.TmVoltPoint parseDelimitedFrom(
      java.io.InputStream input,
      com.google.protobuf.ExtensionRegistryLite extensionRegistry)
      throws java.io.IOException {
    return com.google.protobuf.GeneratedMessageV3
        .parseDelimitedWithIOException(PARSER, input, extensionRegistry);
  }
  public static openfmb.commonmodule.TmVoltPoint parseFrom(
      com.google.protobuf.CodedInputStream input)
      throws java.io.IOException {
    return com.google.protobuf.GeneratedMessageV3
        .parseWithIOException(PARSER, input);
  }
  public static openfmb.commonmodule.TmVoltPoint parseFrom(
      com.google.protobuf.CodedInputStream input,
      com.google.protobuf.ExtensionRegistryLite extensionRegistry)
      throws java.io.IOException {
    return com.google.protobuf.GeneratedMessageV3
        .parseWithIOException(PARSER, input, extensionRegistry);
  }

  @java.lang.Override
  public Builder newBuilderForType() { return newBuilder(); }
  public static Builder newBuilder() {
    return DEFAULT_INSTANCE.toBuilder();
  }
  public static Builder newBuilder(openfmb.commonmodule.TmVoltPoint prototype) {
    return DEFAULT_INSTANCE.toBuilder().mergeFrom(prototype);
  }
  @java.lang.Override
  public Builder toBuilder() {
    return this == DEFAULT_INSTANCE
        ? new Builder() : new Builder().mergeFrom(this);
  }

  @java.lang.Override
  protected Builder newBuilderForType(
      com.google.protobuf.GeneratedMessageV3.BuilderParent parent) {
    Builder builder = new Builder(parent);
    return builder;
  }
  /**
   * <pre>
   * MISSING DOCUMENTATION!!!
   * </pre>
   *
   * Protobuf type {@code commonmodule.TmVoltPoint}
   */
  public static final class Builder extends
      com.google.protobuf.GeneratedMessageV3.Builder<Builder> implements
      // @@protoc_insertion_point(builder_implements:commonmodule.TmVoltPoint)
      openfmb.commonmodule.TmVoltPointOrBuilder {
    public static final com.google.protobuf.Descriptors.Descriptor
        getDescriptor() {
      return openfmb.commonmodule.Commonmodule.internal_static_commonmodule_TmVoltPoint_descriptor;
    }

    @java.lang.Override
    protected com.google.protobuf.GeneratedMessageV3.FieldAccessorTable
        internalGetFieldAccessorTable() {
      return openfmb.commonmodule.Commonmodule.internal_static_commonmodule_TmVoltPoint_fieldAccessorTable
          .ensureFieldAccessorsInitialized(
              openfmb.commonmodule.TmVoltPoint.class, openfmb.commonmodule.TmVoltPoint.Builder.class);
    }

    // Construct using openfmb.commonmodule.TmVoltPoint.newBuilder()
    private Builder() {

    }

    private Builder(
        com.google.protobuf.GeneratedMessageV3.BuilderParent parent) {
      super(parent);

    }
    @java.lang.Override
    public Builder clear() {
      super.clear();
      bitField0_ = 0;
      tmVal_ = null;
      if (tmValBuilder_ != null) {
        tmValBuilder_.dispose();
        tmValBuilder_ = null;
      }
      voltVal_ = 0F;
      return this;
    }

    @java.lang.Override
    public com.google.protobuf.Descriptors.Descriptor
        getDescriptorForType() {
      return openfmb.commonmodule.Commonmodule.internal_static_commonmodule_TmVoltPoint_descriptor;
    }

    @java.lang.Override
    public openfmb.commonmodule.TmVoltPoint getDefaultInstanceForType() {
      return openfmb.commonmodule.TmVoltPoint.getDefaultInstance();
    }

    @java.lang.Override
    public openfmb.commonmodule.TmVoltPoint build() {
      openfmb.commonmodule.TmVoltPoint result = buildPartial();
      if (!result.isInitialized()) {
        throw newUninitializedMessageException(result);
      }
      return result;
    }

    @java.lang.Override
    public openfmb.commonmodule.TmVoltPoint buildPartial() {
      openfmb.commonmodule.TmVoltPoint result = new openfmb.commonmodule.TmVoltPoint(this);
      if (bitField0_ != 0) { buildPartial0(result); }
      onBuilt();
      return result;
    }

    private void buildPartial0(openfmb.commonmodule.TmVoltPoint result) {
      int from_bitField0_ = bitField0_;
      if (((from_bitField0_ & 0x00000001) != 0)) {
        result.tmVal_ = tmValBuilder_ == null
            ? tmVal_
            : tmValBuilder_.build();
      }
      if (((from_bitField0_ & 0x00000002) != 0)) {
        result.voltVal_ = voltVal_;
      }
    }

    @java.lang.Override
    public Builder mergeFrom(com.google.protobuf.Message other) {
      if (other instanceof openfmb.commonmodule.TmVoltPoint) {
        return mergeFrom((openfmb.commonmodule.TmVoltPoint)other);
      } else {
        super.mergeFrom(other);
        return this;
      }
    }

    public Builder mergeFrom(openfmb.commonmodule.TmVoltPoint other) {
      if (other == openfmb.commonmodule.TmVoltPoint.getDefaultInstance()) return this;
      if (other.hasTmVal()) {
        mergeTmVal(other.getTmVal());
      }
      if (other.getVoltVal() != 0F) {
        setVoltVal(other.getVoltVal());
      }
      this.mergeUnknownFields(other.getUnknownFields());
      onChanged();
      return this;
    }

    @java.lang.Override
    public final boolean isInitialized() {
      return true;
    }

    @java.lang.Override
    public Builder mergeFrom(
        com.google.protobuf.CodedInputStream input,
        com.google.protobuf.ExtensionRegistryLite extensionRegistry)
        throws java.io.IOException {
      if (extensionRegistry == null) {
        throw new java.lang.NullPointerException();
      }
      try {
        boolean done = false;
        while (!done) {
          int tag = input.readTag();
          switch (tag) {
            case 0:
              done = true;
              break;
            case 10: {
              input.readMessage(
                  getTmValFieldBuilder().getBuilder(),
                  extensionRegistry);
              bitField0_ |= 0x00000001;
              break;
            } // case 10
            case 21: {
              voltVal_ = input.readFloat();
              bitField0_ |= 0x00000002;
              break;
            } // case 21
            default: {
              if (!super.parseUnknownField(input, extensionRegistry, tag)) {
                done = true; // was an endgroup tag
              }
              break;
            } // default:
          } // switch (tag)
        } // while (!done)
      } catch (com.google.protobuf.InvalidProtocolBufferException e) {
        throw e.unwrapIOException();
      } finally {
        onChanged();
      } // finally
      return this;
    }
    private int bitField0_;

    private openfmb.commonmodule.ClearingTime tmVal_;
    private com.google.protobuf.SingleFieldBuilderV3<
        openfmb.commonmodule.ClearingTime, openfmb.commonmodule.ClearingTime.Builder, openfmb.commonmodule.ClearingTimeOrBuilder> tmValBuilder_;
    /**
     * <pre>
     * MISSING DOCUMENTATION!!!
     * </pre>
     *
     * <code>.commonmodule.ClearingTime tmVal = 1 [(.uml.option_required_field) = true, (.uml.option_multiplicity_min) = 1];</code>
     * @return Whether the tmVal field is set.
     */
    public boolean hasTmVal() {
      return ((bitField0_ & 0x00000001) != 0);
    }
    /**
     * <pre>
     * MISSING DOCUMENTATION!!!
     * </pre>
     *
     * <code>.commonmodule.ClearingTime tmVal = 1 [(.uml.option_required_field) = true, (.uml.option_multiplicity_min) = 1];</code>
     * @return The tmVal.
     */
    public openfmb.commonmodule.ClearingTime getTmVal() {
      if (tmValBuilder_ == null) {
        return tmVal_ == null ? openfmb.commonmodule.ClearingTime.getDefaultInstance() : tmVal_;
      } else {
        return tmValBuilder_.getMessage();
      }
    }
    /**
     * <pre>
     * MISSING DOCUMENTATION!!!
     * </pre>
     *
     * <code>.commonmodule.ClearingTime tmVal = 1 [(.uml.option_required_field) = true, (.uml.option_multiplicity_min) = 1];</code>
     */
    public Builder setTmVal(openfmb.commonmodule.ClearingTime value) {
      if (tmValBuilder_ == null) {
        if (value == null) {
          throw new NullPointerException();
        }
        tmVal_ = value;
      } else {
        tmValBuilder_.setMessage(value);
      }
      bitField0_ |= 0x00000001;
      onChanged();
      return this;
    }
    /**
     * <pre>
     * MISSING DOCUMENTATION!!!
     * </pre>
     *
     * <code>.commonmodule.ClearingTime tmVal = 1 [(.uml.option_required_field) = true, (.uml.option_multiplicity_min) = 1];</code>
     */
    public Builder setTmVal(
        openfmb.commonmodule.ClearingTime.Builder builderForValue) {
      if (tmValBuilder_ == null) {
        tmVal_ = builderForValue.build();
      } else {
        tmValBuilder_.setMessage(builderForValue.build());
      }
      bitField0_ |= 0x00000001;
      onChanged();
      return this;
    }
    /**
     * <pre>
     * MISSING DOCUMENTATION!!!
     * </pre>
     *
     * <code>.commonmodule.ClearingTime tmVal = 1 [(.uml.option_required_field) = true, (.uml.option_multiplicity_min) = 1];</code>
     */
    public Builder mergeTmVal(openfmb.commonmodule.ClearingTime value) {
      if (tmValBuilder_ == null) {
        if (((bitField0_ & 0x00000001) != 0) &&
          tmVal_ != null &&
          tmVal_ != openfmb.commonmodule.ClearingTime.getDefaultInstance()) {
          getTmValBuilder().mergeFrom(value);
        } else {
          tmVal_ = value;
        }
      } else {
        tmValBuilder_.mergeFrom(value);
      }
      bitField0_ |= 0x00000001;
      onChanged();
      return this;
    }
    /**
     * <pre>
     * MISSING DOCUMENTATION!!!
     * </pre>
     *
     * <code>.commonmodule.ClearingTime tmVal = 1 [(.uml.option_required_field) = true, (.uml.option_multiplicity_min) = 1];</code>
     */
    public Builder clearTmVal() {
      bitField0_ = (bitField0_ & ~0x00000001);
      tmVal_ = null;
      if (tmValBuilder_ != null) {
        tmValBuilder_.dispose();
        tmValBuilder_ = null;
      }
      onChanged();
      return this;
    }
    /**
     * <pre>
     * MISSING DOCUMENTATION!!!
     * </pre>
     *
     * <code>.commonmodule.ClearingTime tmVal = 1 [(.uml.option_required_field) = true, (.uml.option_multiplicity_min) = 1];</code>
     */
    public openfmb.commonmodule.ClearingTime.Builder getTmValBuilder() {
      bitField0_ |= 0x00000001;
      onChanged();
      return getTmValFieldBuilder().getBuilder();
    }
    /**
     * <pre>
     * MISSING DOCUMENTATION!!!
     * </pre>
     *
     * <code>.commonmodule.ClearingTime tmVal = 1 [(.uml.option_required_field) = true, (.uml.option_multiplicity_min) = 1];</code>
     */
    public openfmb.commonmodule.ClearingTimeOrBuilder getTmValOrBuilder() {
      if (tmValBuilder_ != null) {
        return tmValBuilder_.getMessageOrBuilder();
      } else {
        return tmVal_ == null ?
            openfmb.commonmodule.ClearingTime.getDefaultInstance() : tmVal_;
      }
    }
    /**
     * <pre>
     * MISSING DOCUMENTATION!!!
     * </pre>
     *
     * <code>.commonmodule.ClearingTime tmVal = 1 [(.uml.option_required_field) = true, (.uml.option_multiplicity_min) = 1];</code>
     */
    private com.google.protobuf.SingleFieldBuilderV3<
        openfmb.commonmodule.ClearingTime, openfmb.commonmodule.ClearingTime.Builder, openfmb.commonmodule.ClearingTimeOrBuilder> 
        getTmValFieldBuilder() {
      if (tmValBuilder_ == null) {
        tmValBuilder_ = new com.google.protobuf.SingleFieldBuilderV3<
            openfmb.commonmodule.ClearingTime, openfmb.commonmodule.ClearingTime.Builder, openfmb.commonmodule.ClearingTimeOrBuilder>(
                getTmVal(),
                getParentForChildren(),
                isClean());
        tmVal_ = null;
      }
      return tmValBuilder_;
    }

    private float voltVal_ ;
    /**
     * <pre>
     * This is an absolute value field.
     * </pre>
     *
     * <code>float voltVal = 2 [(.uml.option_required_field) = true, (.uml.option_multiplicity_min) = 1];</code>
     * @return The voltVal.
     */
    @java.lang.Override
    public float getVoltVal() {
      return voltVal_;
    }
    /**
     * <pre>
     * This is an absolute value field.
     * </pre>
     *
     * <code>float voltVal = 2 [(.uml.option_required_field) = true, (.uml.option_multiplicity_min) = 1];</code>
     * @param value The voltVal to set.
     * @return This builder for chaining.
     */
    public Builder setVoltVal(float value) {

      voltVal_ = value;
      bitField0_ |= 0x00000002;
      onChanged();
      return this;
    }
    /**
     * <pre>
     * This is an absolute value field.
     * </pre>
     *
     * <code>float voltVal = 2 [(.uml.option_required_field) = true, (.uml.option_multiplicity_min) = 1];</code>
     * @return This builder for chaining.
     */
    public Builder clearVoltVal() {
      bitField0_ = (bitField0_ & ~0x00000002);
      voltVal_ = 0F;
      onChanged();
      return this;
    }
    @java.lang.Override
    public final Builder setUnknownFields(
        final com.google.protobuf.UnknownFieldSet unknownFields) {
      return super.setUnknownFields(unknownFields);
    }

    @java.lang.Override
    public final Builder mergeUnknownFields(
        final com.google.protobuf.UnknownFieldSet unknownFields) {
      return super.mergeUnknownFields(unknownFields);
    }


    // @@protoc_insertion_point(builder_scope:commonmodule.TmVoltPoint)
  }

  // @@protoc_insertion_point(class_scope:commonmodule.TmVoltPoint)
  private static final openfmb.commonmodule.TmVoltPoint DEFAULT_INSTANCE;
  static {
    DEFAULT_INSTANCE = new openfmb.commonmodule.TmVoltPoint();
  }

  public static openfmb.commonmodule.TmVoltPoint getDefaultInstance() {
    return DEFAULT_INSTANCE;
  }

  private static final com.google.protobuf.Parser<TmVoltPoint>
      PARSER = new com.google.protobuf.AbstractParser<TmVoltPoint>() {
    @java.lang.Override
    public TmVoltPoint parsePartialFrom(
        com.google.protobuf.CodedInputStream input,
        com.google.protobuf.ExtensionRegistryLite extensionRegistry)
        throws com.google.protobuf.InvalidProtocolBufferException {
      Builder builder = newBuilder();
      try {
        builder.mergeFrom(input, extensionRegistry);
      } catch (com.google.protobuf.InvalidProtocolBufferException e) {
        throw e.setUnfinishedMessage(builder.buildPartial());
      } catch (com.google.protobuf.UninitializedMessageException e) {
        throw e.asInvalidProtocolBufferException().setUnfinishedMessage(builder.buildPartial());
      } catch (java.io.IOException e) {
        throw new com.google.protobuf.InvalidProtocolBufferException(e)
            .setUnfinishedMessage(builder.buildPartial());
      }
      return builder.buildPartial();
    }
  };

  public static com.google.protobuf.Parser<TmVoltPoint> parser() {
    return PARSER;
  }

  @java.lang.Override
  public com.google.protobuf.Parser<TmVoltPoint> getParserForType() {
    return PARSER;
  }

  @java.lang.Override
  public openfmb.commonmodule.TmVoltPoint getDefaultInstanceForType() {
    return DEFAULT_INSTANCE;
  }

}

